

ALTER TABLE S_KLJUCI MODIFY PREDPONA VARCHAR2(100 CHAR);

ALTER TABLE S_KLJUCI MODIFY PRIPONA VARCHAR2(100 CHAR);

INSERT INTO S_KLJUCI (IDKLJUC, STEVEC, PREDPONA, PRIPONA, TIP, MESEC, DAN, LETO, DATUM, RESET, VIDEN) 
VALUES
('FISCALIZATION', 1, NULL, '%LOCATION%%CASHIERNR%', 1, 0, 0, 0, NULL, 0, 1);

INSERT INTO S_KLJUCI_LETO (IDKLJUC, LETO, STEVEC, ID_KLJUCI_LETO)
VALUES
('FISCALIZATION', 2013, (SELECT STEVEC FROM S_KLJUCI_LETO WHERE LETO=2013 AND IDKLJUC='RACUN'), (SELECT MAX(ID_KLJUCI_LETO)+1 FROM S_KLJUCI_LETO)); 

UPDATE S_KLJUCI
SET STEVEC=(SELECT MAX(ID_KLJUCI_LETO)+1 FROM S_KLJUCI_LETO)
WHERE IDKLJUC='S_KLJUCI_LETO';
INSERT INTO MARINA_SEQUENCES (TABLENAME, FIELDNAME, SEQUENCE_NAME, COUNTER_TYPE) 
VALUES 
('SALDKONT_FISC', 'ID_SALDKONT_FISC', 'SALDKONT_FISC_SEQ', 'S_KLJUCI');

CREATE TABLE SALDKONT_FISC
  (
    ID_SALDKONT_FISC  NUMBER,
    ID_SALDKONT       NUMBER,
    ID_SALDKONT_ZAP   NUMBER,
    DATUM_KREIRANJA   DATE,
    USER_KREIRANJA    VARCHAR2(20 CHAR),
    VRSTA             VARCHAR2(10 CHAR),
    STEVILKA          VARCHAR2(30 CHAR),
    NSTEVILKA         NUMBER,
    ZA_PLACILO        NUMBER,
    GOVERNMENT        VARCHAR2(100 CHAR),
    GOVERNMENT_CODE   VARCHAR2(100 CHAR),
    PARAGON_ST        VARCHAR2(20 CHAR), 
    LOKAC             VARCHAR2(10 CHAR), 
    CONSTRAINT PK_SALDKONT_FISC PRIMARY KEY (ID_SALDKONT_FISC)
  );

CREATE INDEX IX_SALDKONT_FISC1 ON SALDKONT_FISC (ID_SALDKONT);

CREATE INDEX IX_SALDKONT_FISC2 ON SALDKONT_FISC (ID_SALDKONT_ZAP);

INSERT INTO SALDKONT_FISC 
(ID_SALDKONT_FISC, ID_SALDKONT, DATUM_KREIRANJA, USER_KREIRANJA, VRSTA, STEVILKA, NSTEVILKA, GOVERNMENT, GOVERNMENT_CODE, PARAGON_ST, LOKAC, ZA_PLACILO)
SELECT ID_SALDKONT, ID_SALDKONT, DATUM_KREIRANJA, USER_KREIRANJA, 'S', (N_KNJIZBE || LOKAC || '1') AS BROJ_RACUNA, N_KNJIZBE, GOVERMENT, GOVERMENT_CODE, PARAGON_ST, LOKAC, PROTIVREDNOST
FROM SALDKONT WHERE VRSTA_RACUNA='RAC' AND DATUM>='01.01.2013'  AND GOVERMENT IS NOT NULL
;

INSERT INTO MARINA_SEQUENCES (TABLENAME, FIELDNAME, SEQUENCE_NAME, COUNTER_TYPE) 
VALUES 
('SALDKONT_FISC', 'ID_SALDKONT_FISC', 'SALDKONT_FISC_SEQ', 'S_KLJUCI');

ALTER TABLE MARINA_SEQUENCES ADD CHECKED VARCHAR2(1 CHAR);

UPDATE MARINA_SEQUENCES SET CHECKED='N' WHERE CHECKED IS NULL;

DROP VIEW V_RACUN;

CREATE VIEW V_RACUN AS 
SELECT S.ID_SALDKONT_FISC AS ID_RACUN, SK.F_DAVCNA_STEVILKA AS OIB, 1 AS OBVEZATNIK, S.DATUM_KREIRANJA AS CAS, 'P' AS SLIJEDNOST, 
S.STEVILKA AS BROJ_RACUNA, 
S.NSTEVILKA AS NBROJ_RACUNA, S.LOKAC AS POSLOVNI_PROSTOR, 1 AS NAPLATNI_UREDAJ, S.ZA_PLACILO AS IZNOS, 
(CASE PL.PLACIL WHEN 1 THEN (CASE NP.ID_CARDS WHEN 'GOD' THEN 'G' WHEN 'GOT' THEN 'G' WHEN 'KAR' THEN 'K' WHEN 'CEK' THEN 'C' ELSE 'O' END) ELSE 'O' END) AS NACIN_PLACANJA , 
S.GOVERNMENT AS GOVERMENT, S.GOVERNMENT_CODE AS GOVERMENT_CODE, S.PARAGON_ST AS PARAGON_RACUN, U.DAVCNA_ST AS OIB_DJELATNIKA, 2 AS VERZIJA
FROM SALDKONT_FISC S
JOIN SALDKONT R ON S.ID_SALDKONT=R.ID_SALDKONT 
JOIN SALDKONT_KUPEC SK ON R.ID_SALDKONT=SK.ID_SALDKONT
JOIN NUSER U ON U.NUSER=S.USER_KREIRANJA
LEFT OUTER JOIN EXCHANGE E ON R.ID_EXCHANGE=E.ID
LEFT OUTER JOIN (SELECT ID_MENJAVE, ID_CARDS FROM MONEY WHERE ROWNUM=1) NP ON E.ID=NP.ID_MENJAVE
LEFT OUTER JOIN (SELECT ID_MENJAVE, COUNT(*) AS PLACIL FROM MONEY GROUP BY ID_MENJAVE) PL ON E.ID=PL.ID_MENJAVE
WHERE R.VRSTA_RACUNA IN ('RAC', 'AKO') AND S.ID_SALDKONT_ZAP IS NULL
UNION
SELECT S.ID_SALDKONT_FISC AS ID_RACUN, SK.F_DAVCNA_STEVILKA AS OIB, 1 AS OBVEZATNIK, S.DATUM_KREIRANJA AS CAS, 'P' AS SLIJEDNOST, 
S.STEVILKA AS BROJ_RACUNA, 
S.NSTEVILKA AS NBROJ_RACUNA, S.LOKAC AS POSLOVNI_PROSTOR, 1 AS NAPLATNI_UREDAJ, S.ZA_PLACILO AS IZNOS, 
(CASE PL.PLACIL WHEN 1 THEN (CASE NP.ID_CARDS WHEN 'GOD' THEN 'G' WHEN 'GOT' THEN 'G' WHEN 'KAR' THEN 'K' WHEN 'CEK' THEN 'C' ELSE 'O' END) ELSE 'O' END) AS NACIN_PLACANJA , 
S.GOVERNMENT AS GOVERMENT, S.GOVERNMENT_CODE AS GOVERMENT_CODE, S.PARAGON_ST AS PARAGON_RACUN, U.DAVCNA_ST AS OIB_DJELATNIKA, 2 AS VERZIJA
FROM SALDKONT_FISC S
JOIN SALDKONT_ZAP Z ON S.ID_SALDKONT_ZAP=S.ID_SALDKONT_ZAP
JOIN SALDKONT R ON R.ID_SALDKONT=Z.ID_PL_SALDKONT 
JOIN SALDKONT_KUPEC SK ON R.ID_SALDKONT=SK.ID_SALDKONT
JOIN NUSER U ON U.NUSER=S.USER_KREIRANJA
LEFT OUTER JOIN EXCHANGE E ON R.ID_EXCHANGE=E.ID
LEFT OUTER JOIN (SELECT ID_MENJAVE, ID_CARDS FROM MONEY WHERE ROWNUM=1) NP ON E.ID=NP.ID_MENJAVE
LEFT OUTER JOIN (SELECT ID_MENJAVE, COUNT(*) AS PLACIL FROM MONEY GROUP BY ID_MENJAVE) PL ON E.ID=PL.ID_MENJAVE
WHERE R.VRSTA_RACUNA IN ('AKO')
;

DROP VIEW V_RACUN_PNP;

CREATE VIEW V_RACUN_PNP AS
SELECT SF.ID_SALDKONT_FISC AS ID_RACUN, D.STOPNJA AS POREZ_STOPA, SUM(D.ZNESEK_OSNOVE) AS OSNOVICA, SUM(D.ZNESEK_DAVKA) AS POREZ_IZNOS 
FROM SALDKONT_FISC SF
JOIN SALDKONT SA ON SF.ID_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
JOIN M_STORITVE S ON R.ID_STORITVE=S.ID_STORITVE
JOIN M_STORITVE_DAVEK D ON S.ID_STORITVE=D.ID_STORITVE 
WHERE D.VRSTA='PNP'
GROUP BY SF.ID_SALDKONT_FISC, D.STOPNJA
UNION
SELECT SF.ID_SALDKONT_FISC AS ID_RACUN, D.STOPNJA AS POREZ_STOPA, SUM(D.ZNESEK_OSNOVE*(-1)) AS OSNOVICA, SUM(D.ZNESEK_DAVKA*(-1)) AS POREZ_IZNOS 
FROM SALDKONT_FISC SF
JOIN SALDKONT_ZAP SZ ON SF.ID_SALDKONT_ZAP=SZ.ID_SALDKONT_ZAP
JOIN SALDKONT SA ON SZ.ID_PL_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
JOIN M_STORITVE S ON R.ID_STORITVE=S.ID_STORITVE
JOIN M_STORITVE_DAVEK D ON S.ID_STORITVE=D.ID_STORITVE 
WHERE D.VRSTA='PNP'
GROUP BY SF.ID_SALDKONT_FISC, D.STOPNJA
;

DROP VIEW V_RACUN_PDV;

CREATE VIEW V_RACUN_PDV AS
SELECT ID_RACUN, POREZ_STOPA, SUM(OSNOVICA) AS OSNOVICA, SUM(POREZ_IZNOS) AS POREZ_IZNOS FROM
(
SELECT SF.ID_SALDKONT_FISC AS ID_RACUN, D.STOPNJA AS POREZ_STOPA, SUM(D.ZNESEK_OSNOVE) AS OSNOVICA, SUM(D.ZNESEK_DAVKA) AS POREZ_IZNOS 
FROM SALDKONT_FISC SF
JOIN RACUN_DATA R ON SF.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE  AND D.VRSTA='DDV'
WHERE D.ID_STORITVE IS NOT NULL
GROUP BY SF.ID_SALDKONT_FISC, D.STOPNJA
union
SELECT SF.ID_SALDKONT_FISC AS ID_RACUN, R.DAV_STOPNJA AS POREZ_STOPA, SUM(R.NETO) AS OSNOVICA, SUM(R.ZN_DAVKA) AS POREZ_IZNOS 
FROM SALDKONT_FISC SF
JOIN RACUN_DATA R ON SF.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE 
WHERE D.ID_STORITVE IS NULL
GROUP BY SF.ID_SALDKONT_FISC, R.DAV_STOPNJA
union
SELECT SF.ID_SALDKONT_FISC AS ID_RACUN, D.STOPNJA AS POREZ_STOPA, SUM(D.ZNESEK_OSNOVE*(-1)) AS OSNOVICA, SUM(D.ZNESEK_DAVKA*(-1)) AS POREZ_IZNOS 
FROM SALDKONT_FISC SF
JOIN SALDKONT_ZAP SZ ON SF.ID_SALDKONT_ZAP=SZ.ID_SALDKONT_ZAP
JOIN SALDKONT SA ON SZ.ID_PL_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE  AND D.VRSTA='DDV'
WHERE D.ID_STORITVE IS NOT NULL
GROUP BY SF.ID_SALDKONT_FISC, D.STOPNJA
union
SELECT SF.ID_SALDKONT_FISC AS ID_RACUN, R.DAV_STOPNJA AS POREZ_STOPA, SUM(R.NETO*(-1)) AS OSNOVICA, SUM(R.ZN_DAVKA*(-1)) AS POREZ_IZNOS 
FROM SALDKONT_FISC SF
JOIN SALDKONT_ZAP SZ ON SF.ID_SALDKONT_ZAP=SZ.ID_SALDKONT_ZAP
JOIN SALDKONT SA ON SZ.ID_PL_SALDKONT=SA.ID_SALDKONT
JOIN RACUN_DATA R ON SA.ID_SALDKONT=R.ID_SALDKONT
LEFT OUTER JOIN M_STORITVE_DAVEK D ON R.ID_STORITVE=D.ID_STORITVE 
WHERE D.ID_STORITVE IS NULL
GROUP BY SF.ID_SALDKONT_FISC, R.DAV_STOPNJA
) DDV
GROUP BY ID_RACUN, POREZ_STOPA
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (282, SYSDATE, '5.5', 202, 'Fiskalizacija ver 2');